String gameState;
boolean lowQuality = false;
boolean goLeft = false;
boolean goRight = false;
int score = 0;


class eIntroScreen extends elScene
{
	private
        elFont font;
        elFont title;
        elSprite tower;

	public
    	eIntroScreen()
        {
        	super();

            fType = "eIntroScreen";
            refreshUniqueID();

            title = new elFont();
            title.fontColor = new elColor(0, 0, 0);
            title.fontSize = 20;
            title.loadFromFile("DejaVuSans.svg");



            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

            tower = new elSprite();
            tower.loadFromFile("tower.png");
            tower.position.x = width - 200;
            tower.position.y = 15;


        }

        void draw()
        {
        	background(255);

            title.textOut(new elVector2i(200, 10), "But I Love Her");

            font.textOut(new elVector2i(10, 50), "The first time you looked at the princess.");
            font.textOut(new elVector2i(10, 70), "of this kingdom you know you were in love");
            font.textOut(new elVector2i(10, 90), "with her.");
            font.textOut(new elVector2i(10, 110), "Apparently the tower she lives in has been");
            font.textOut(new elVector2i(10, 130), "attacked by evil ghosts. Get rid of the ghosts");
            font.textOut(new elVector2i(10, 150), "If that's not a confession of love...");
            font.textOut(new elVector2i(10, 200), "A and S to move left and right and C to attack enemies");
            font.textOut(new elVector2i(10, 300), "Click to continue");

            tower.draw();
        }

        void update()
        {
        	if (mousePressed) gameState = "gamelevel";
        }
}

class eGameLevel extends elScene
{
	private
    	elSprite gHero_Left;
        elSprite gHero_Right;

    	elSprite gPicture;
        elSprite gDoor;

        elSprite gTreasure;
        elSprite gDiamond;

        elSprite ghost1;
        elSprite ghost2;

        elFont font;

        int ghost1life;
        int ghost2life;

        int herolife;

        int hposx;
        boolean directionRight;
        boolean gamelost;

    public
    	eGameLevel()
        {
        	super();
            fType = "eGameLevel";
            refreshUniqueID();

            hposx = 10;
            directionRight = true;
            gamelost = false;

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

            gHero_Left = new elSprite();
            gHero_Left.loadFromFile("hero_left.png");
            gHero_Left.position.y = height - 90;

            gHero_Right = new elSprite();
            gHero_Right.loadFromFile("hero_left.png");
            gHero_Right.position.y = height - 90;

            gPicture = new elSprite();
            gPicture.loadFromFile("picture.png");
            gPicture.position.x = 200;
            gPicture.position.y = 130;

            gDoor = new elSprite();
            gDoor.loadFromFile("door.png");
            gDoor.position.x = width - 60;
            gDoor.position.y = height - 90;

            ghost1 = new elSprite();
            ghost1.loadFromFile("ghost.png");
            ghost1.position.x = 170;
            ghost1.position.y = height - 90;

            ghost2 = new elSprite();
            ghost2.loadFromFile("ghost.png");
            ghost2.position.x = 400;
            ghost2.position.y = height - 90;

            gTreasure = new elSprite();
            gTreasure.loadFromFile("treasure.png");
            gTreasure.position.x = 30;
            gTreasure.position.y = height - 70;

            gDiamond = new elSprite();
            gDiamond.loadFromFile("diamond.png");
            gDiamond.position.x = 200;
            gDiamond.position.y = height - 40;

            ghost1life = 20;
            ghost2life = 20;

            herolife = 100;
        }

        void draw()
        {
        	background(235);

            GUI.box(new elRect(0, height - 10, width, height), new elColor(190, 190, 190));

            gPicture.draw();
            gDoor.draw();

            ghost1.draw();
            ghost2.draw();

            if (directionRight) gHero_Right.draw();
            else gHero_Left.draw();


            GUI.box(new elRect(20, 20, herolife * 2, 25), new elColor(255, 0, 0));
            font.textOut(new elVector2i(width - 100, 20), "Score: " + str(score));
        }

        void update()
        {
        	if (gamelost)
            {
            	font.textOut(new elVector2i(300, 50), "You lost. Refresh this site to retry.");
            }
            else
            {

            	if (keyPressed)
                {
                	if (key == 'a' || key == 'A')
                    {
                    	goLeft = true;
                        directionRight = false;
                    }
                    if (key == 's' || key == 'S')
                    {
                    	goRight = true;
                        directionRight = true;
                    }

                    if (key == 'c' || key == 'C')
                    {
                    	if ((abs(ghost1.position.x - hposx) < 60) && ghost1.visible) ghost1life--;
                		if ((abs(ghost2.position.x - hposx) < 60) && ghost2.visible) ghost2life--;
                    }
                }
                else
                {
                	goLeft = false;
                    goRight = false;
                }



            	if (goLeft)
                {
                	if (hposx > 0) hposx = hposx - 3;

                }

                if (goRight)
                {
                	if (hposx < (width - 70)) hposx = hposx + 3;

                }

                gHero_Left.position.x = hposx;
                gHero_Right.position.x = hposx;


                if (hposx > (width - 80)) gameState = "outroScreen";


                if (herolife <= 0) gamelost = true;

                if (ghost1life < 20)
                {
                	if (ghost1.position.x > 0) ghost1.position.x = ghost1.position.x - 2;
                    else ghost1.position.x = ghost1.position.x + 2;
                }
                if (ghost2life < 20)
                {
                	if (ghost2.position.x > 0) ghost2.position.x = ghost2.position.x - 2;
                    else ghost2.position.x = ghost2.position.x + 2;
                }

                if (ghost1life <= 0) ghost1.visible = false;
                if (ghost2life <= 0) ghost2.visible = false;

                if ((abs(hposx - ghost1.position.x) < 30) && ghost1.visible) herolife--;
                if ((abs(ghost2.position.x - hposx) < 30) && ghost2.visible) herolife--;

                if (!ghost1.visible)
                {
                	gTreasure.draw();

                    if ((abs(hposx - gTreasure.position.x) < 30) && gTreasure.visible)
                    {
                    	score = score + 100;
                        gTreasure.visible = false;
                    }
                }

                if (!ghost2.visible)
                {
                	gDiamond.draw();

                    if ((abs(hposx - gDiamond.position.x) < 30) && gDiamond.visible)
                    {
                    	score = score + 200;
                        gDiamond.visible = false;
                    }
                }

            }
        }
}

class eOutroScreen extends elScene
{
	private
    	elSprite gHero;
        elSprite gPrincess;
        elFont font;

    public
    	eOutroScreen()
        {
        	super();
            fType = "eOutroScreen";
            refreshUniqueID();

            gHero = new elSprite();
            gHero.loadFromFile("hero_cutscene.png");
            gHero.position.x = 100;
            gHero.position.y = height - 140;

            gPrincess = new elSprite();
            gPrincess.loadFromFile("princess.png");
            gPrincess.position.x = 400;
            gPrincess.position.y = height - 140;

            font = new elFont();
            font.fontColor = new elColor(0, 0, 0);
            font.fontSize = 14;
            font.loadFromFile("DejaVuSans.svg");

        }

        void draw()
        {
        	background(235);

            GUI.box(new elRect(0, height - 10, width, height), new elColor(190, 190, 190));

            gHero.draw();
            gPrincess.draw();

            if (score == 0)
            {
            	font.textOut(new elVector2i(100, 40), "What? You didn't bring me anything? Get out now!");
            }
            else
            {
            	if (score == 300)
                {
                	font.textOut(new elVector2i(100, 40), "Thanks for the stuff. Now get out - please.");
                }
                else
                {
                	font.textOut(new elVector2i(100, 40), "Well that's not exactly what I wanted, you loser! You have to try again!");
                }
            }
        }

        void update()
        {

        }
}
